<template>
  <div>
    <div>
<CModal
           title="Info"
      size="sm"
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>


<CCardBody>
     <h5>Trace Taken TB Report</h5>
    
    <CDataTable
      :items="items"
      :fields="fields"
      table-filter
      items-per-page-select
      :items-per-page="5"
      pagination
      hover
      striped
      border
      sorter
     >
   

<!--Adding Customs buttons to each row -->
    <template #show_details="{item}" >      
      <CButton size="sm" color="dark" class="ml-1" @click="ShowDetailsModal=true; SelectMaterial(item)"> Details </CButton>
    </template>

    </CDataTable>
      
  </CCardBody>

 </div>
<div id="overlay" v-if="ShowAddModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Add New Material</h5>
    <button type="button" class="close"  @click="ShowAddModal=false">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-7">
<form action="#" method="POST">

<div class="form-group">
<input type="text" name="Material_Id" class="form-control form-control-lg" placeholder="Material Id" v-model="newMaterial.material_Id">
</div>

<div class="form-group">
<input type="text" name="Material_Code" class="form-control form-control-lg" placeholder="Material Code" v-model="newMaterial.material_Code">
</div>

<div class="form-group">
<input type="text" name="workCent_Id" class="form-control form-control-lg" placeholder="Work Center Id" v-model="newMaterial.workCent_Id">
</div>

<div class="form-group">
<input type="text" name="material_CreationDate" class="form-control form-control-lg" placeholder="Material Creation Date"  v-model="newMaterial.material_CreationDate">
</div>

<div class="form-group">
<input type="text" name="status" class="form-control form-control-lg" placeholder="Material status"  v-model="newMaterial.status">
</div>

<div class="form-group">
<CButton size="sm" color="info" class=""  @click="ShowAddModal=false;addMaterials();" > Add Material </CButton>
</div>

</form>
 </div>
</div>
</div>
 </div>

<!-- Show Details Modal -->
<div id="overlay" v-if="ShowDetailsModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Material Details</h5>
    <button type="button" class="close"  @click="ShowDetailsModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body p-4">

<form action="#" method="POST">
<div class="form-group">
<input type="text" name="Material_Id" class="form-control form-control-lg" placeholder="Material Id" v-model="newMaterial.material_Id">
</div>

<div class="form-group">
<input type="text" name="Material_Code" class="form-control form-control-lg" placeholder="Material Code" v-model="newMaterial.material_Code">
</div>

<div class="form-group">
<input type="text" name="workCent_Id" class="form-control form-control-lg" placeholder="Work Center Id" v-model="newMaterial.workCent_Id">
</div>

<div class="form-group">
<input type="text" name="material_CreationDate" class="form-control form-control-lg" placeholder="Material Creation Date"  v-model="newMaterial.material_CreationDate">
</div>

<div class="form-group">
<input type="text" name="status" class="form-control form-control-lg" placeholder="Material status"  v-model="newMaterial.status">
</div>

<div class="form-group">
<button class="btn btn-info btn-block btn-lg"  @click="ShowDetailsModal=false;" > Close </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Show Update Modal -->
<div id="overlay" v-if="ShowUpdateModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Update Material</h5>
    <button type="button" class="close"  @click="ShowUpdateModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<form action="#" method="POST">
<div class="form-group">
<input type="text" name="Material_Id" class="form-control form-control-lg" placeholder="Material Id" v-model="newMaterial.material_Id">
</div>

<div class="form-group">
<input type="text" name="Material_Code" class="form-control form-control-lg" placeholder="Material Code" v-model="newMaterial.material_Code">
</div>

<div class="form-group">
<input type="text" name="workCent_Id" class="form-control form-control-lg" placeholder="Work Center Id" v-model="newMaterial.workCent_Id">
</div>

<div class="form-group">
<input type="text" name="material_CreationDate" class="form-control form-control-lg" placeholder="Material Creation Date"  v-model="newMaterial.material_CreationDate">
</div>

<div class="form-group">
<input type="text" name="status" class="form-control form-control-lg" placeholder="Material status"  v-model="newMaterial.status">
</div>

<div class="form-group">
<button class="btn btn-info btn-block btn-lg"  @click="ShowUpdateModal=false;UpdateMaterials();" > Update Material </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Delete Modal -->
<div id="overlay" v-if="ShowDeleteModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Delete Material</h5>
    <button type="button" class="close"  @click="ShowDeleteModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<h4 class="text-danger"> Are you sure want to delete the material ? </h4>
<h5> You are deleting {{ this.CurrentMaterial.material_Id +' || '+ this.CurrentMaterial.material_Code }}</h5>
<hr>
<button class="btn btn-danger btn-lg" @click="ShowDeleteModal=false; deleteItem();getAllMaterialDetails()  "> Yes </button>
&nbsp;&nbsp;&nbsp;&nbsp;  
<button class="btn btn-success btn-lg" @click="ShowDeleteModal=false"> No </button>
</div>
</div>
</div>
</div>
</div>
</template>

<script>
const items = [
  { key: 'production_Id',  },
  { key: 'mhe_Id', _style:'min-width:100px;' },
  { key: 'requestID', _style:'min-width:50px;' }, 
  { key: 'takenToTB_ReqTime',     _style: 'width:1%',  },
  { key: 'takenToTB_By',     _style: 'width:1%',  },
  { key: 'issue_Status',     _style: 'width:1%',  },
 ]   
const apiget =  'Trace_Taken_ToTB/'
//import CTableWrapper from '.@/Table.vue' 
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)

export default {
   //components: { CTableWrapper },
  data ()
  {
     return {
    items: items.map((item, id) => { return {...item, id}}),
    
     fields: [
       // { key: 'show_details1',  label: '',  _style: 'width:1%', },
            
              { key: 'production_Id' , label: 'Id', _style: 'width:1%',},
              { key: 'mhe_Id', label: 'MHE', },
              { key: 'requestID', label: 'Request Id',  },             
              //{ key: 'material_Type',  label: 'Material Type',  _style: 'width:12%', },
              { key: 'takenToTB_ReqTime',  label: 'Request Time',  _style: 'width:12%', },
              { key: 'takenToTB_By',  label: 'Requested By',  _style: 'width:12%', },
              { key: 'issue_Status',  label: 'Status',  _style: 'width:12%', },
               //{ key: 'show_details',  label: '',  _style: 'width:35%', },     
      ],
     
  details: [],
  collapseDuration: 0,
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentMaterial:"",
  ShowUpdateModal:"",
  ShowDetailsModal:"",
  smallModal: false,
  newMaterial: {material_Id:0,material_Code:"",workCent_Id:0,material_Type:"",material_CreationDate:new Date(),material_CreatedBy:"",status:1,}, }
  },
  selectOptions: [
    { 
          value: 1, 
          label: 'FLAP'
    },
    { 
          value: 2, 
          label: 'TYRE'
    }
    ],
    selectedOption: 1,

  
  mounted()
  {
   this.getAllMaterialDetails();
  },

  methods:
  {
   getAllMaterialDetails: function()
   {
  // Vue.axios.get('http://172.23.8.193:8095/api/FGS_FIFO_Material_Master')
  //alert(this.$url +'Trace_Taken_TB_Report')
   Vue.axios.get(this.$url +apiget)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.items =response.data//.filter(x => x.status == 1);
       // this.subitems = response.data.fgS_FIFO_Material_Type_Master;

       }
    });
   },

   
  
  
  
  
   
   
    
    },
  
    

}
</script>

<style scoped>
#overlay{
  position:fixed;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>